#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# editor: mufei(ypdh@qq.com tel:15712150708)
'''
牧飞 _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''
#+--------------------------------------------------------------------
#|   宝塔第三方应用开发 mfwaf
#+--------------------------------------------------------------------

#本代码使用GPL协议，解释权归牧飞(ypdh@qq.com)所有。

#本插件需要在/www/server/nginx/conf/nginx.conf配置文件中添加 include mfngxwaf.conf 或者
#python_include /www/server/nginx/mfwaf/mfngxwaf.py;
#python_access "access(r)";
#此两行信息才会有效！



import time
import json
import os
import sys
import re
from IPy import IP
#import requests
#import base64

if sys.version_info[0] == 2:
    try:
        from cStringIO import StringIO
    except:
        from StringIO import StringIO
else:
    from io import BytesIO as StringIO

wafpath = '/www/server/nginx/mfwaf' #
sys.path.append(wafpath)
from vilidate import vie, vieCode
mfwaflog = "/www/server/nginx/mfwaf/mfwaf.log"



conf={
    "cc":{'r1':0,'r2':0,'r3':0,'r4':0,'r5':0,'r6':0,'r7':0,'r8':0, 'a1':0, 'b1':0,
          'c1':0,'c2':'','d1':0,'d2':'','d3':'','d4':'',
          'e1':0, 'e2':0, 'e3':""
          },
    'ipcdns':{},
    'uriblacks':{},
    'uablacks':{},
    'ipwhites':{}, 
    'ipzhizhu':{},
    'ipblacks':{},
    'captcha_html':'',
    }
    

def readTxt(path):
    if not os.path.isfile(path):
        return []
    with open(path,'r') as f:
        txt = f.read()
    txt = re.sub(r'<!--[\s\S]*?-->', ' ', txt)
    L = []
    for line in txt.split('\n'):
        s = line.split('#')[0].strip()
        if s: L.append(s)
    return L


int_ip = lambda x: '.'.join([str(x/(256**i)%256) for i in range(3,-1,-1)])
ip_int = lambda x:sum([256**j*int(i) for j,i in enumerate(x.split('.')[::-1])])
def readIpTxt(path, d=None):
    L = readTxt(path)
    if not L: return {}
    if d is None: d = {}
    for s in L:
        if s[0]=='(': s=s[1:-1]
        if '|' in s:
            ss = s.split('|')
        else:
            ss = [s]
        for e in ss:
            if '-' in e:
                ip1,ip2 = e.split('-', 1)
                try:
                    ip1_num = ip_int(ip1.strip())
                    ip2_num = ip_int(ip2.strip())
                    for i in range(ip1_num,ip2_num+1): d[int_ip(i)]= 1
                except:
                    logfile.write(path+' '+str(e)+' error\n')
            else:
                try:
                    for ip in IP(e): d[str(ip)] = 1
                except:
                    logfile.write(path+' '+str(e)+' error\n')
    return d


def readReTxt(path):
    L = readTxt(path)
    if not L: return []
    _L = []
    for s in L:
        try:
            re.search(s,'')
            _L.append(s)
        except:
            pass
    return _L
            
                
                


ipzhizhutxtpath = os.path.join(wafpath, 'conf', 'ipzhizhu.txt')

logfile = open(mfwaflog,'a+') #a+

with open(os.path.join(wafpath,'conf','captcha.png'),'rb') as f:
    TmpPng = f.read()

def loadwaf():
    wafccpath = os.path.join(wafpath, 'config.json')
    if os.path.isfile(wafccpath):
        with open(wafpath+'/config.json') as f:
            conf.update(json.load(f))
        a1 = conf['cc'].get('a1','')
        if not a1: pass
        elif a1=='*': conf['cc']['a1']=''
        else:
            conf['cc']['a1'] = tuple(a1.split('|'))
            
    captchatxtpath = os.path.join(wafpath, 'conf', 'captcha.txt')
    if os.path.isfile(captchatxtpath):
        with open(captchatxtpath) as f:
            conf['captcha_html'] = f.read()

    ipblacktxtpath = os.path.join(wafpath, 'conf', 'ipblacks.txt')
    if os.path.isfile(ipblacktxtpath):
        conf['ipblacks'] = readIpTxt(ipblacktxtpath)

    ipwhitetxtpath = os.path.join(wafpath, 'conf', 'ipwhites.txt')
    if os.path.isfile(ipwhitetxtpath):
        conf['ipwhites'] = readIpTxt(ipwhitetxtpath)

    if os.path.isfile(ipzhizhutxtpath):
        conf['ipzhizhu'].update(readIpTxt(ipzhizhutxtpath))

    ipcdntxtpath = os.path.join(wafpath, 'conf', 'ipcdns.txt')
    if os.path.isfile(ipcdntxtpath):
        conf['ipcdns'] = readIpTxt(ipcdntxtpath)

    uriblacktxtpath = os.path.join(wafpath, 'conf', 'uriblacks.txt')
    if os.path.isfile(uriblacktxtpath):
        conf['uriblacks'] = readReTxt(uriblacktxtpath)
    
    uablacktxtpath = os.path.join(wafpath, 'conf', 'uablacks.txt')
    if os.path.isfile(uablacktxtpath):
        conf['uablacks'] = readReTxt(uablacktxtpath)

    conf.update({
            'ipvalids':{}, #验证名单
            'ipgreys':{},  #灰名单
            'ipblues':{},  #蓝名单
            "mincfg":{"n":0,'count':0, 'data':{}}, #分钟m
            "seccfg":{"n":0,'count':0, 'data':{}}, #秒钟s
            "hostcfg":{'hosts':{}, 'data':{}},
            'r5_second': 0,
        })


loadwaf()
import ngx
    

def get_real_ip(r):
    ip  = r.var['remote_addr']
    xip = r.var['x_forwarded_for']
    cip = r.var['http_client_ip']
    rip = r.var['x_real_ip']
    if xip or cip or rip:
        if ip in conf['ipcdns']:
            if cip:
                ip = cip
            elif rip:
                ip = rip
            elif xip:
                ip = xip.split(',')[-1] 
    return ip

def isIPwhite(r, ip):
    #IP白名单 蜘蛛池名单
    if ip=='127.0.0.1':
        localApi(r)
    return ip in conf['ipwhites']

def isHostMore(r, t):
    cc = conf['cc']
    if not cc.get('e1') and not cc.get('e2'):
        return 0

    host = r.var['host']
    if conf['hostcfg']['hosts'].get(host, 0) > t:
        return 1

    hData = conf['hostcfg']['data']
    n = hData.setdefault(host, 0)
    hData[host] = n+1
    
    if n > cc['e1']:
        conf['hostcfg']['hosts'][host] = t + cc['e2']*60
        hData.pop(host, None)
        return 1
    return 0
    


def isIPblack(r, ip):
    if ip in conf['ipblacks']: return 1
    if conf['cc'].get('c1'):
        if not conf['cc'].get('c2'):
            return 1
        uri = r.var['uri']
        if uri not in ('','/') and re.search(conf['cc']['c2'], uri):
            return 1
    return 0

def isUAblack(r, ip):
    ua = r.var['http_user_agent']
    s = 0
    for k in conf['uablacks']:
        try:
            s = re.search(k,ua)
        except:
            pass
        if s: return 1
    return 0

def isURIblack(r, ip):
    uri = r.var['uri']
    for k in conf['uriblacks']:
        try:
            s = re.search(k,uri)
        except:
            s = 0
        if s: return 1
    return 0

def isIPgrey(r, ip, t):
    if ip in conf['ipgreys']:
        if conf['ipgreys'][ip] > t:
            return 1
        else:
            conf['ipgreys'].pop(ip,None)

def isIPblue(r, ip, t):
    if ip in conf['ipblues']:
        return 1

def isZhizhu(r, ip):
    if ip in conf['ipzhizhu']:
        return 1
    if r.var['uri']=='/robots.txt' and conf['cc'].get('b1'):
        cmdstring = "host %s"%ip
        a = os.popen(cmdstring).read()
        if re.search("[.](baidu|sogou|googlebot|qq|360|google|search.msn|soso|yahoo).com.?$",a, flags=re.I):
            #r.ho['Mf-Waf-Robot'] = a
            if os.path.isfile(ipzhizhutxtpath):
                with open(ipzhizhutxtpath,'a+') as f:
                    f.write('\n'+ip+' #'+a)
            else:
                logfile.write('\nRobotHost:'+ip+' #'+str(a)+'\n')
            conf['ipzhizhu'][ip] = 1
            return 1
        
def isReferer(r):
    host = r.var['host']
    ref  = r.var['http_referer']
    if ref=='-': ref=''
    
    cc = conf['cc']
    if host in ref:
        return 1
    if not ref :
        if not cc.get('d4'):
            return 1
        if re.search(cc['d4'], r.var['http_user_agent']):
            return 1
        

    uri = r.var['uri']
    if uri in ('/','/index.php','index.html',''): return 1        
    if cc.get('d3'):
        if not re.search(cc['d3'], uri):
            return 1
        
    if cc.get('d2'):
        d2 = cc['d2'].strip()
        d2 = '(%s)$'%d2
        if re.search(d2, ref):
            return 1

    return 0
 
        
    
    
def localApi(r):
    uri = r.var['uri']
    rs = '{"status":1}'
    real = 0
    
    if uri=='/mfwaf-reload':
        loadwaf()
        real = 1
    elif uri=='/mfwaf-ipgreys':
        rs = json.dumps(conf['ipgreys'])
        real = 1
    elif uri=='/mfwaf-ipvalids':
        rs = json.dumps(conf['ipvalids'])
        real = 1
    elif uri=='/mfwaf-ipblues':
        rs = json.dumps(conf['ipblues'])
        real = 1
    elif uri=='/mfwaf-config':
        rs = json.dumps(conf)
        real = 1
    if real:
        r.status = 200
        r.ho['Content-Length'] = str(len(rs))
        r.sendHeader()
        r.send(rs, ngx.SEND_LAST)
    
    
def CCCheck(r, ip, t):
    #t = int(time.time())
    m = int(t/60)
    
    if m!=conf['mincfg']['n']: #分钟检测
        conf['mincfg'] = {"n":m,'count':0, 'data':{}}
        conf['hostcfg']['data'] = {}
        
    mData = conf['mincfg']['data']
    mData.setdefault(ip, 0) 
    mData[ip] += 1
    conf['mincfg']['count'] += 1


    if t!=conf['seccfg']['n']: #秒钟检测
        conf['seccfg'] = {"n":t,'count':0, 'data':{}}
    sData = conf['seccfg']['data']
    sData.setdefault(ip, 0) 
    sData[ip] += 1
    conf['seccfg']['count'] += 1
    #logfile.write('\n:'+str(conf['mincfg']['count'])+'\n');logfile.flush()

    if ip in conf['ipblues']: #r7,r8
        if sData[ip] > conf['cc']['r7'] > 0:
            conf['ipvalids'][ip] = [1,'']
            conf['ipblues'].pop(ip, None)
            return 1
        if mData[ip] > conf['cc']['r8'] > 0:
            conf['ipvalids'][ip] = [1,'']
            conf['ipblues'].pop(ip, None)
            return 1
        return 0

    if ip in conf['ipvalids']: #r6
        if conf['ipvalids'][ip][0] > 120:
            conf['ipgreys'][ip] = t + (conf['cc']['r6']>1 and conf['cc']['r6'] or 3600*24)
            return 1
        
        conf['ipvalids'][ip][0] += 1
        return 1
    
    if sData[ip] > conf['cc']['r1'] > 0: #r1
        conf['ipvalids'][ip] = [1,'']
        return 1
    if mData[ip] > conf['cc']['r2'] > 0: #r2
        conf['ipvalids'][ip] = [1,'']
        return 1

    if conf['r5_second'] > t: #r5
        return 1
    
    if conf['cc']['r3'] > 0 and len(conf['seccfg']['data'])>conf['cc']['r3']: #r3
        if conf['cc']['r5'] > 0:
            conf['r5_second'] += conf['cc']['r5'] * 60
        return 1
    if conf['cc']['r4'] > 0 and len(conf['mincfg']['data'])>conf['cc']['r4']: #r4
        if conf['cc']['r5'] > 0:
            conf['r5_second'] += conf['cc']['r5'] * 60
        return 1
    
    return 0


def captcha(r, ip):
    tmpPth = '/www/server/nginx/mfwaf/tmp.png'
    
    try:
        #im, v = vieCode().GetCodeImage(80,4)
        im, v = vie.GetCodeImage(80,4)
        v = ''.join(v)
        out = StringIO()
        im.save(out, "png")
        out.seek(0)
        s = out.read()
        #im.save(tmpPth)
        #s = open(tmpPth,'rb').read()
    except:
        s = TmpPng
        v = "rjme"
    
    if ip in conf['ipvalids']:
        conf['ipvalids'][ip][0] += 1
        conf['ipvalids'][ip][1] = v
    else:
        conf['ipvalids'][ip] = [1, v]
    s = str(s)
    
    r.status = 200
    r.ho['Content-Type'] = "image/png"
    #r.ho['Connection'] = "close"
    r.ho['Content-Length'] = str(len(s))
    r.sendHeader()
    
    r.send(s, ngx.SEND_LAST)
    

def captcha_auth(r,ip, t):
    if ip in conf['ipblues']:
        s = '{"status":1}'
        conf['ipvalids'].pop(ip, None)
        conf['mincfg']['data'].pop(ip, None)
        
    elif ip in conf['ipvalids']:
        if  r.arg['captcha'].lower() == conf['ipvalids'][ip][1].lower():
            s = '{"status":1}'
            conf['ipblues'][ip] = t
            conf['ipvalids'].pop(ip, None)
            conf['mincfg']['data'].pop(ip, None)
            #conf['seccfg']['data'].pop(ip, None)
        else:
            conf['ipvalids'][ip][0] += 4
            s = '{"status":0}'
    else:
        #r.ho['Mf-Waf-Msg'] = str(r.var['captcha']+'---')
        s = '{"status":1}'
    
    r.status = 200

    

    r.ho['Cache-Control'] = "no-cache"
    r.ho['Pragma'] = "no-cache"
    r.ho['Expires'] = "Thu, 19 Nov 1981 08:52:00 GMT"
    r.ho['Content-Length'] = str(len(s))
    #r.ho['Connection'] = "close"
    
    r.sendHeader()
    r.send(s, ngx.SEND_LAST)
        
    
    
def access(r):
    ip = get_real_ip(r)
    t = int(time.time())
    uri = r.var['uri']
    
    if isIPwhite(r, ip):
        pass
    
    elif isHostMore(r, t):
        r.ho['Mf-Waf-Msg'] = "go away isHostMore"
        r.status = 404
        r.sendHeader()   
        r.send('', ngx.SEND_LAST)
        
    elif isIPblack(r, ip):
        r.ho['Mf-Waf-Msg'] = "go away isIPblack"
        r.status = 404
        r.sendHeader()   
        r.send('', ngx.SEND_LAST)
    
    elif isUAblack(r, ip):
        r.ho['Mf-Waf-Msg'] = "go away isUAblack"
        r.status = 404
        r.sendHeader()   
        r.send('', ngx.SEND_LAST)
    elif isURIblack(r, ip):
        r.ho['Mf-Waf-Msg'] = "go away isURIblack"
        r.status = 404
        r.sendHeader()   
        r.send('', ngx.SEND_LAST)
    elif isZhizhu(r, ip):
        pass
    elif isIPgrey(r, ip, t):
        r.ho['Mf-Waf-Msg'] = "go away isIPgrey"
        r.status = 404
        r.sendHeader()   
        r.send('', ngx.SEND_LAST)
    elif conf['cc'].get('d1') and not isReferer(r):
        r.ho['Mf-Waf-Msg'] = "go away isReferer"
        r.status = 404
        r.sendHeader()   
        r.send('', ngx.SEND_LAST)
    else:
        if  uri == "/mfwaf-captcha.png":
            captcha(r, ip)
        elif uri == "/mfwaf-auth":
            captcha_auth(r, ip, t)
        else:
            a1 = conf['cc'].get('a1','')
            if not a1 or uri.endswith(a1):
                cc = CCCheck(r, ip, t)
            else:
                cc = 0
            
            if cc:
                
                if conf['captcha_html']:
                    r.status = 200
                    #r.ho['Connection'] = "close"
                    r.ho['Content-Type'] = "text/html"
                    s = conf['captcha_html']
                    r.ho['Content-Length'] = str(len(s))
                    r.sendHeader()
                    r.send(s, ngx.SEND_LAST)
                else:
                    r.status = 404
                    r.sendHeader()
                    r.send('', ngx.SEND_LAST)
            
                
  
